#!/usr/bin/env bash
set -e

# Check that linuxdeploy and required plugins are available
if ! command -v linuxdeploy &> /dev/null; then
    echo "linuxdeploy not found in PATH"
    exit 1
fi

# Check that the required plugins are available
if ! linuxdeploy --list-plugins 2>/dev/null | grep -q appimage; then
    echo "linuxdeploy-plugin-appimage not found"
    exit 1
fi
if ! linuxdeploy --list-plugins 2>/dev/null | grep -q checkrt; then
    echo "linuxdeploy-plugin-checkrt not found"
    exit 1
fi


if [ "$#" -ne 2 ]; then
    echo "Usage: $0 APPIMAGE_TARGET APPIMAGE_DIR"
    exit 1
fi

APPIMAGE_TARGET="$1"
APPIMAGE_DIR="$2"

export NO_STRIP=true # Some files fail to strip for some reason
export LDAI_OUTPUT="$APPIMAGE_TARGET"

linuxdeploy --appdir "$APPIMAGE_DIR" -e poppi -d resources/poppi.desktop -i resources/poppi.png -o appimage -p checkrt
