#pragma once

#include <FLAC++/decoder.h>

#include "flac_compatability.hpp"

class FlacDecoder : public FLAC::Decoder::File
{
public:
    FlacDecoder();
    ~FlacDecoder();
    bool getMoreData();

    uint32_t bps;
    uint32_t channels;
    uint32_t sampleRate;
    uint64_t totalSamples; // note: this is actually total samples divided by channels

    uint64_t unreadSamplesLeft;

    float *rawData = nullptr;
    int rawDataAllocatedLength = 0;
    int rawDataLength = 0;
    int rawDataWritePosition = 0;
    int rawDataReadPosition = 0;

protected:
    virtual ::FLAC__StreamDecoderWriteStatus write_callback(const ::FLAC__Frame *frame, const FLAC__int32 *const buffer[]);
    virtual void metadata_callback(const ::FLAC__StreamMetadata *metadata);
    virtual void error_callback(::FLAC__StreamDecoderErrorStatus status);

private:
    float *overflowSamples = nullptr;
    int overflowSamplesAllocatedLength = 0;
    int overflowSamplesLength = 0;
    int overflowSamplesReadPosition = 0;
};