#pragma once

#include <stdint.h>

#include <stdexcept>
#include <string>

#include "protocolEnums.hpp"

#define MAX_MESSAGE_LENGTH 65535

#if __BIG_ENDIAN__
#define htonll(x) (x)
#define ntohll(x) (x)
#else
#define htonll(x) (((uint64_t)htonl((x) & 0xFFFFFFFF) << 32) | htonl((x) >> 32))
#define ntohll(x) (((uint64_t)ntohl((x) & 0xFFFFFFFF) << 32) | ntohl((x) >> 32))
#endif

namespace networking {
class NotConnectedException : public std::runtime_error
{
  public:
    NotConnectedException(const std::string& message)
        : std::runtime_error(message) {}
};

void start(std::string host, std::string port);
void sendMessage(SendMessageType type, const unsigned char* message, uint16_t length);
void sendMessage(SendMessageType type);
} // namespace networking
