#include "timing.hpp"

#include <mutex>

static std::mutex syncDiffernceMutex;
static std::chrono::milliseconds _syncDifference;

int64_t serverTimeToLocalTime(std::chrono::milliseconds serverTime)
{
    std::lock_guard<std::mutex> lg(syncDiffernceMutex);
    return (serverTime + _syncDifference).count() * 1000;
}

void setSyncDifference(std::chrono::milliseconds syncDifference)
{
    std::lock_guard<std::mutex> lg(syncDiffernceMutex);
    _syncDifference = syncDifference;
}
